(function ($) {

  /**
   * Implements Drupal.behaviors for the Dashboard module.
   */
  Drupal.behaviors.dashboard.setupDrawer = function () {
    $('div.customize .canvas-content input').click(Drupal.behaviors.dashboard.exitCustomizeMode);
    $('div.customize .canvas-content')
      .append('<div class="dashboard-done-button ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only">'
      + '<a class="button ui-button-text" href="' 
      + Drupal.settings.dashboard.dashboard 
      + '">' 
      + Drupal.t('Done') 
      + '</a></div>');

    // Initialize drag-and-drop.
    var regions = $('#dashboard div.region');
    regions.sortable({
      connectWith: regions,
      cursor: 'move',
      cursorAt: {top:0},
      dropOnEmpty: true,
      items: '> div.block, > div.disabled-block',
      placeholder: 'block-placeholder ui-state-highlight ui-corner-all clearfix',
      tolerance: 'pointer',
      start: Drupal.behaviors.dashboard.start,
      over: Drupal.behaviors.dashboard.over,
      sort: Drupal.behaviors.dashboard.sort,
      update: Drupal.behaviors.dashboard.update
    });
    
    // Add hover state
    $('.ui-button').once('ui-button').Fhover();
    $('.disabled-block').once('ui-widget-content').Ahover();
  };

  
  /**
   * Plugin for changing class according
   * to jQueryUI specification
   */
  $.fn.Fhover = function (options) {
    var defaults = {
        hoverClass: 'ui-state-hover'
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      $(this).hover(function() {
        $(this)
        .toggleClass(options.hoverClass);
      }, function() {
        $(this)
        .toggleClass(options.hoverClass);
      });
    });
  };
  
  /**
   * Plugin for changing class according
   * to jQueryUI specification
   */
  $.fn.Ahover = function (options) {
    var defaults = {
        hoverClass: 'ui-state-hover',
        activeClass: 'ui-state-active'
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      $(this).hover(function() {
        $(this)
        .removeClass(options.activeClass)
        .addClass(options.hoverClass);
      }, function() {
        $(this)
        .removeClass(options.hoverClass)
        .addClass(options.activeClass);
      });
    });
  };
})(jQuery);